﻿--[[
DiHook 1.1.6-1-gd01a23d
Date: 2014-12-07T07:18:11Z
Author: Clausi
DiHook.lua
Shows missing dark intent in the corresponding actionbar tooltip
]]--

local DiScan = {}
local DarkIntent = 109773

local function UnitHasBuff(unit, buff)
	for i=1, 40 do
		local name, _, _, _, _, _, _, _, _ = UnitBuff(unit, i)
		if (name == GetSpellInfo(buff)) then
			return true
		end
	end
	return false
end

local function DiScanner()
	local DiScan = ""
	local party = ""
	local count = 1

	if(UnitInRaid("player")) then
		party = "raid"
		count = 40
	elseif(UnitInParty("player")) then
		party = "party"
		count = 4
	end

	if(party == "raid" or party == "party") then
		for i = 1, count, 1 do
			if 	UnitExists(party..i) and
				not UnitHasBuff(party..i, DarkIntent)
			then 
				DiScan = DiScan .. UnitName(party..i) .. " "
			end				
		end
	end
	-- Scan player when not in party or in 5man party
	if(not UnitHasBuff("player", DarkIntent) and 
		(party == "party" or party == "")
	) then 
		DiScan = DiScan .. UnitName("player")
	end
	
	return DiScan
end

local function DiHook(tooltip)
	local _, _, SpellId = tooltip:GetSpell()
	if ( SpellId == DarkIntent ) then
		local DiScan
		DiScan = DiScanner()
		if(#(DiScan) > 0) then 
			tooltip:AddLine(" ", 1, 1, 1)
			tooltip:AddLine("Missing on:", 1, 1, 1)
			tooltip:AddLine(DiScan, 1, 1, 1, 1)
		end
	end
	tooltip:Show()
end

if GameTooltip:GetScript("OnTooltipSetSpell") then
	GameTooltip:HookScript("OnTooltipSetSpell", DiHook)
else
	GameTooltip:SetScript("OnTooltipSetSpell", DiHook)
end 
